DES-SERT - A Simple and Extensible Routing Framework for Testbeds: NET - S N M P // A G E N T _ X

# NET - S N M P // A G E N T _ X

EXTERNAL / PUBLIC. More...

## Data Structures
struct | dessert_agentx_appstats
| An abstract data type representing some statistical datum. More...
struct | dessert_agentx_appparams
| An abstract data type representing some parameter. More...
struct | dessert_agentx_appstats_cb_entry
| A callback entry representing a statistical datum. More...
struct | dessert_agentx_appparams_cb_entry
| A callback entry representing a parameter. More...
## Defines
#define | DESSERT_APPSTATS_VALUETYPE_BOOL 0
| Flag indicating the dessert_agentx_appstats_t is of type bool.
#define | DESSERT_APPSTATS_VALUETYPE_INT32 1
| Flag indicating the dessert_agentx_appstats_t is of type int32.
#define | DESSERT_APPSTATS_VALUETYPE_UINT32 2
| Flag indicating the dessert_agentx_appstats_t is of type uint32.
#define | DESSERT_APPSTATS_VALUETYPE_COUNTER64 3
| Flag indicating the dessert_agentx_appstats_t is of type counter64.
#define | DESSERT_APPSTATS_VALUETYPE_OCTETSTRING 4
| Flag indicating the dessert_agentx_appstats_t is of type octetstring.
#define | DESSERT_APPSTATS_NODEORLINK_NONE 0
| Flag indicating the dessert_agentx_appstats_t does not contain information regarding a node or a link.
#define | DESSERT_APPSTATS_NODEORLINK_NODE 1
| Flag indicating the dessert_agentx_appstats_t contains information regarding a node.
#define | DESSERT_APPSTATS_NODEORLINK_LINK 2
| Flag indicating the dessert_agentx_appstats_t contains information regarding a link.
#define | DESSERT_APPSTATS_BOOL_TRUE 1
| What is considered to be TRUE in a dessert_agentx_appstats_t.
#define | DESSERT_APPSTATS_BOOL_FALSE 0
| What is considered to be FALSE in a dessert_agentx_appstats_t.
#define | DESSERT_APPPARAMS_VALUETYPE_BOOL 0
| Flag indicating the dessert_agentx_appparams_t is of type bool.
#define | DESSERT_APPPARAMS_VALUETYPE_INT32 1
| Flag indicating the dessert_agentx_appparams_t is of type int32.
#define | DESSERT_APPPARAMS_VALUETYPE_UINT32 2
| Flag indicating the dessert_agentx_appparams_t is of type uint32.
#define | DESSERT_APPPARAMS_VALUETYPE_OCTETSTRING 3
| Flag indicating the dessert_agentx_appparams_t is of type octetstring.
#define | DESSERT_APPPARAMS_BOOL_TRUE 1
| What is considered to be TRUE in a dessert_agentx_appparams_t.
#define | DESSERT_APPPARAMS_BOOL_FALSE 0
| What is considered to be FALSE in a dessert_agentx_appparams_t.
#define | DESSERT_APPSTATS_CB_BULK 1
| Flag indicating if a appstats callback entry is of type bulk.
#define | DESSERT_APPSTATS_CB_NOBULK 2
| Flag indicating if a appstats callback entry is of type nobulk.
## Typedefs
typedef struct dessert_agentx_appstats | dessert_agentx_appstats_t
| An abstract data type representing some statistical datum.
typedef struct dessert_agentx_appparams | dessert_agentx_appparams_t
| An abstract data type representing some parameter.
typedef int | dessert_agentx_appstatscb_get_t (struct dessert_agentx_appstats *appstats)
| Callback type to call if the AppstatsTable is asked for by some snmp client.
typedef int | dessert_agentx_appparamscb_get_t (struct dessert_agentx_appparams *appparams)
| Callback type to call if the AppparamsTable is asked for by some snmp client.
typedef int | dessert_agentx_appparamscb_set_t (struct dessert_agentx_appparams *appparams)
| Callback type to call if the specific row represented by this callback is going to be set by some snmp client.
typedef struct dessert_agentx_appstats_cb_entry | dessert_agentx_appstats_cb_entry_t
| A callback entry representing a statistical datum.
typedef struct dessert_agentx_appparams_cb_entry | dessert_agentx_appparams_cb_entry_t
| A callback entry representing a parameter.
## Functions
dessert_agentx_appstats_t * | dessert_agentx_appstats_new (void)
| Creates and initializes a new dessert_agentx_appstats_t.
void | dessert_agentx_appstats_destroy (dessert_agentx_appstats_t *appstat)
| Frees a dessert_agentx_appstats_t.
dessert_agentx_appstats_cb_entry_t * | dessert_agentx_appstats_add (dessert_agentx_appstatscb_get_t *c)
| Adds an application statistics callback.
dessert_agentx_appstats_cb_entry_t * | dessert_agentx_appstats_add_bulk (dessert_agentx_appstatscb_get_t *c)
| Adds an application statistics bulk callback.
int | dessert_agentx_appstats_del (dessert_agentx_appstats_cb_entry_t *e)
| Deletes an application statistics callback.
dessert_agentx_appparams_t * | dessert_agentx_appparam_new (void)
| Creates and initializes a new dessert_agentx_appparams_t.
void | dessert_agentx_appparam_destroy (dessert_agentx_appparams_t *appparam)
| Frees a dessert_agentx_appparams_t.
dessert_agentx_appparams_cb_entry_t * | dessert_agentx_appparams_add (dessert_agentx_appparamscb_get_t *get, dessert_agentx_appparamscb_set_t *set)
| Adds an application parameter callback.
int | dessert_agentx_appparams_del (dessert_agentx_appparams_cb_entry_t *e)
| Deletes an application parameter callback.

## Detailed Description

EXTERNAL / PUBLIC.

## Define Documentation

#define DESSERT_APPPARAMS_BOOL_FALSE 0

What is considered to be FALSE in a dessert_agentx_appparams_t.

#define DESSERT_APPPARAMS_BOOL_TRUE 1

What is considered to be TRUE in a dessert_agentx_appparams_t.

#define DESSERT_APPPARAMS_VALUETYPE_BOOL 0

Flag indicating the dessert_agentx_appparams_t is of type bool.

#define DESSERT_APPPARAMS_VALUETYPE_INT32 1

Flag indicating the dessert_agentx_appparams_t is of type int32.

#define DESSERT_APPPARAMS_VALUETYPE_OCTETSTRING 3

Flag indicating the dessert_agentx_appparams_t is of type octetstring.

#define DESSERT_APPPARAMS_VALUETYPE_UINT32 2

Flag indicating the dessert_agentx_appparams_t is of type uint32.

#define DESSERT_APPSTATS_BOOL_FALSE 0

What is considered to be FALSE in a dessert_agentx_appstats_t.

#define DESSERT_APPSTATS_BOOL_TRUE 1

What is considered to be TRUE in a dessert_agentx_appstats_t.

#define DESSERT_APPSTATS_CB_BULK 1

Flag indicating if a appstats callback entry is of type bulk.

#define DESSERT_APPSTATS_CB_NOBULK 2

Flag indicating if a appstats callback entry is of type nobulk.

#define DESSERT_APPSTATS_NODEORLINK_LINK 2

Flag indicating the dessert_agentx_appstats_t contains information regarding a link.

#define DESSERT_APPSTATS_NODEORLINK_NODE 1

Flag indicating the dessert_agentx_appstats_t contains information regarding a node.

#define DESSERT_APPSTATS_NODEORLINK_NONE 0

Flag indicating the dessert_agentx_appstats_t does not contain information regarding a node or a link.

#define DESSERT_APPSTATS_VALUETYPE_BOOL 0

Flag indicating the dessert_agentx_appstats_t is of type bool.

#define DESSERT_APPSTATS_VALUETYPE_COUNTER64 3

Flag indicating the dessert_agentx_appstats_t is of type counter64.

#define DESSERT_APPSTATS_VALUETYPE_INT32 1

Flag indicating the dessert_agentx_appstats_t is of type int32.

#define DESSERT_APPSTATS_VALUETYPE_OCTETSTRING 4

Flag indicating the dessert_agentx_appstats_t is of type octetstring.

#define DESSERT_APPSTATS_VALUETYPE_UINT32 2

Flag indicating the dessert_agentx_appstats_t is of type uint32.

## Typedef Documentation

typedef struct dessert_agentx_appparams_cb_entry dessert_agentx_appparams_cb_entry_t

A callback entry representing a parameter.

typedef struct dessert_agentx_appparams dessert_agentx_appparams_t

An abstract data type representing some parameter.

typedef int dessert_agentx_appparamscb_get_t(struct dessert_agentx_appparams *appparams)

Callback type to call if the AppparamsTable is asked for by some snmp client.

Parameters:

  | *appstats | dessert_agentx_appparams_t the parameter to be filled out

Return values:

  | DESSERT_OK | on success
  | DESSERT_ERR | to remove the corresponding callback entry

typedef int dessert_agentx_appparamscb_set_t(struct dessert_agentx_appparams *appparams)

Callback type to call if the specific row represented by this callback is going to be set by some snmp client.

Parameters:

  | *appstats | dessert_agentx_appparams_t the new value

Return values:

  | DESSERT_OK | on success
  | DESSERT_ERR | otherwise

typedef struct dessert_agentx_appstats_cb_entry dessert_agentx_appstats_cb_entry_t

A callback entry representing a statistical datum.

typedef struct dessert_agentx_appstats dessert_agentx_appstats_t

An abstract data type representing some statistical datum.

typedef int dessert_agentx_appstatscb_get_t(struct dessert_agentx_appstats *appstats)

Callback type to call if the AppstatsTable is asked for by some snmp client.

Parameters:

  | *appstats | dessert_agentx_appstats_t the statistical datum to be filled out

Return values:

  | DESSERT_OK | on success
  | DESSERT_ERR | to remove the corresponding callback entry

## Function Documentation

void dessert_agentx_appparam_destroy | ( | dessert_agentx_appparams_t * | appparam | ) |

Frees a dessert_agentx_appparams_t.

Parameters:

  | appparam | the dessert_agentx_appparams_t to be freed

Warning:
  Only use this method to free a dessert_agentx_appparams_t which was allocated with dessert_agentx_appparams_new().

See also:
  dessert_agentx_appparams_new()

Description:

dessert_agentx_appparams_t* dessert_agentx_appparam_new | ( | void |  | ) |

Creates and initializes a new dessert_agentx_appparams_t.

Returns:
  the new dessert_agentx_appparams_t

Warning:
  A dessert_agentx_appparams_t allocated with this function must be freed with dessert_agentx_appparams_destroy().

See also:
  dessert_agentx_appparams_destroy()

Description:

dessert_agentx_appparams_cb_entry_t* dessert_agentx_appparams_add | ( | dessert_agentx_appparamscb_get_t * | get,
|  | dessert_agentx_appparamscb_set_t * | set |
| ) |  |  |

Adds an application parameter callback.

Parameters:

  `[in]` | *c | the callback to add

Return values:

  | pointer | to the corresponding callback entry on success
  | NULL | otherwise

Description:

int dessert_agentx_appparams_del | ( | dessert_agentx_appparams_cb_entry_t * | e | ) |

Deletes an application parameter callback.

Parameters:

  | *e | pointer to a callback entry

Return values:

  | DESSERT_OK | on success
  | DESSERT_ERR | otherwise

See also:
  dessert_agentx_appparams_add()

Description:

dessert_agentx_appstats_cb_entry_t* dessert_agentx_appstats_add | ( | dessert_agentx_appstatscb_get_t * | c | ) |

Adds an application statistics callback.

Parameters:

  `[in]` | *c | the callback to add

Return values:

  | pointer | to the corresponding callback entry on success
  | NULL | otherwise

Description:

dessert_agentx_appstats_cb_entry_t* dessert_agentx_appstats_add_bulk | ( | dessert_agentx_appstatscb_get_t * | c | ) |

Adds an application statistics bulk callback.

Parameters:

  `[in]` | *c | the callback to add

Return values:

  | pointer | to the corresponding callback entry on success
  | NULL | otherwise

Description:

int dessert_agentx_appstats_del | ( | dessert_agentx_appstats_cb_entry_t * | e | ) |

Deletes an application statistics callback.

Parameters:

  | *e | pointer to a callback entry

Return values:

  | DESSERT_OK | on success
  | DESSERT_ERR | otherwise

See also:
  dessert_agentx_appstats_add()
  dessert_agentx_appstats_add_bulk()

Description:

void dessert_agentx_appstats_destroy | ( | dessert_agentx_appstats_t * | appstat | ) |

Frees a dessert_agentx_appstats_t.

Parameters:

  | appstat | the dessert_agentx_appstats_t to be freed

Warning:
  Only use this method to free a dessert_agentx_appstats_t which was allocated with dessert_agentx_appstats_new().

See also:
  dessert_agentx_appstats_new()

Description:

dessert_agentx_appstats_t* dessert_agentx_appstats_new | ( | void |  | ) |

Creates and initializes a new dessert_agentx_appstats_t.

Returns:
  the new dessert_agentx_appstats_t

Warning:
  A dessert_agentx_appstats_t allocated with this function must be freed with dessert_agentx_appstats_destroy().

See also:
  dessert_agentx_appstats_destroy()

Description: